# Class CheckBox

java.lang.Object
com.codename1.ui.Component
com.codename1.ui.Label
com.codename1.ui.Button
com.codename1.ui.CheckBox

All Implemented Interfaces:
  `Animation, Editable, ActionSource<ActionEvent>, StyleListener, IconHolder, ReleasableComponent, SelectableIconHolder, TextHolder`

public class CheckBox extends Button

CheckBox is a button that can be selected or deselected and displays its state to the user. Check out `com.codename1.ui.RadioButton` for a more exclusive selection approach. Both components support a toggle button mode using the `com.codename1.ui.Button#setToggle(boolean)` API.

    CheckBox cb1 = new CheckBox("CheckBox No Icon");
    cb1.setSelected(true);
    CheckBox cb2 = new CheckBox("CheckBox With Icon", icon);
    CheckBox cb3 = new CheckBox("CheckBox Opposite True", icon);
    CheckBox cb4 = new CheckBox("CheckBox Opposite False", icon);
    cb3.setOppositeSide(true);
    cb4.setOppositeSide(false);
    RadioButton rb1 = new RadioButton("Radio 1");
    RadioButton rb2 = new RadioButton("Radio 2");
    RadioButton rb3 = new RadioButton("Radio 3", icon);
    new ButtonGroup(rb1, rb2, rb3);
    rb2.setSelected(true);
    hi.add(cb1).add(cb2).add(cb3).add(cb4).add(rb1).add(rb2).add(rb3);

- ## Field Summary

  ### Fields inherited from class Button

  `STATE_DEFAULT, STATE_PRESSED, STATE_ROLLOVER`
  Modifier and Type
  Field
  Description
  `static final int`
  `STATE_DEFAULT`
  Indicates the default state of a button which is neither pressed nor focused
  `static final int`
  `STATE_PRESSED`
  Indicates the pressed state of a button
  `static final int`
  `STATE_ROLLOVER`
  Indicates the rollover state of a button which is equivalent to focused for most uses

  ### Fields inherited from class Component

  `BASELINE, BOTTOM, BRB_CENTER_OFFSET, BRB_CONSTANT_ASCENT, BRB_CONSTANT_DESCENT, BRB_OTHER, CENTER, CROSSHAIR_CURSOR, DEFAULT_CURSOR, DRAG_REGION_IMMEDIATELY_DRAG_X, DRAG_REGION_IMMEDIATELY_DRAG_XY, DRAG_REGION_IMMEDIATELY_DRAG_Y, DRAG_REGION_LIKELY_DRAG_X, DRAG_REGION_LIKELY_DRAG_XY, DRAG_REGION_LIKELY_DRAG_Y, DRAG_REGION_NOT_DRAGGABLE, DRAG_REGION_POSSIBLE_DRAG_X, DRAG_REGION_POSSIBLE_DRAG_XY, DRAG_REGION_POSSIBLE_DRAG_Y, E_RESIZE_CURSOR, HAND_CURSOR, LEFT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NW_RESIZE_CURSOR, RIGHT, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, TOP, W_RESIZE_CURSOR, WAIT_CURSOR`
  Modifier and Type
  Field
  Description
  `static final int`
  `BASELINE`
  Alignment to the baseline constraint
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `BRB_CENTER_OFFSET`
  Baseline resize behavior constant used to properly align components.
  `static final int`
  `BRB_CONSTANT_ASCENT`
  Baseline resize behavior constant used to properly align components.
  `static final int`
  `BRB_CONSTANT_DESCENT`
  Baseline resize behavior constant used to properly align components.
  `static final int`
  `BRB_OTHER`
  Baseline resize behavior constant used to properly align components.
  `static final int`
  `CENTER`
  Indicates a Component center alignment
  `static final int`
  `CROSSHAIR_CURSOR`
  The crosshair cursor type.
  `static final int`
  `DEFAULT_CURSOR`
  The default cursor
  `static final int`
  `DRAG_REGION_IMMEDIATELY_DRAG_X`
  Used by getDragRegionStatus to indicate immediate dragability
  `static final int`
  `DRAG_REGION_IMMEDIATELY_DRAG_XY`
  Used by getDragRegionStatus to indicate immediate dragability
  `static final int`
  `DRAG_REGION_IMMEDIATELY_DRAG_Y`
  Used by getDragRegionStatus to indicate immediate dragability
  `static final int`
  `DRAG_REGION_LIKELY_DRAG_X`
  Used by getDragRegionStatus to indicate likely dragability
  `static final int`
  `DRAG_REGION_LIKELY_DRAG_XY`
  Used by getDragRegionStatus to indicate likely dragability
  `static final int`
  `DRAG_REGION_LIKELY_DRAG_Y`
  Used by getDragRegionStatus to indicate likely dragability
  `static final int`
  `DRAG_REGION_NOT_DRAGGABLE`
  Used by getDragRegionStatus to indicate no dragability
  `static final int`
  `DRAG_REGION_POSSIBLE_DRAG_X`
  Used by getDragRegionStatus to indicate limited dragability
  `static final int`
  `DRAG_REGION_POSSIBLE_DRAG_XY`
  Used by getDragRegionStatus to indicate limited dragability
  `static final int`
  `DRAG_REGION_POSSIBLE_DRAG_Y`
  Used by getDragRegionStatus to indicate limited dragability
  `static final int`
  `E_RESIZE_CURSOR`
  The east-resize cursor type.
  `static final int`
  `HAND_CURSOR`
  The hand cursor type.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `MOVE_CURSOR`
  The move cursor type.
  `static final int`
  `N_RESIZE_CURSOR`
  The north-resize cursor type.
  `static final int`
  `NE_RESIZE_CURSOR`
  The north-east-resize cursor type.
  `static final int`
  `NW_RESIZE_CURSOR`
  The north-west-resize cursor type.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `S_RESIZE_CURSOR`
  The south-resize cursor type.
  `static final int`
  `SE_RESIZE_CURSOR`
  The south-east-resize cursor type.
  `static final int`
  `SW_RESIZE_CURSOR`
  The south-west-resize cursor type.
  `static final int`
  `TEXT_CURSOR`
  The text cursor type.
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `W_RESIZE_CURSOR`
  The west-resize cursor type.
  `static final int`
  `WAIT_CURSOR`
  The wait cursor type.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CheckBox()`
  Constructs a checkbox with no text
  `CheckBox(Image icon)`
  Constructs a checkbox with the given icon
  `CheckBox(String text)`
  Constructs a checkbox with the given text
  `CheckBox(String text, Image icon)`
  Constructs a checkbox with the given text and icon

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addChangeListener(ActionListener l)`
  Adds a listener to be notified when the the checkbox's selected value changes.
  `void`
  `bindProperty(String prop, BindTarget target)`
  Binds the given property name to the given bind target
  `protected Dimension`
  `calcPreferredSize()`
  Calculates the preferred size based on component content.
  `static CheckBox`
  `createToggle(Image icon)`
  Shorthand for creating the check box setting the icon/text and making it into a toggle button
  `static CheckBox`
  `createToggle(String text)`
  Shorthand for creating the check box setting the icon/text and making it into a toggle button
  `static CheckBox`
  `createToggle(String text, Image icon)`
  Shorthand for creating the check box setting the icon/text and making it into a toggle button
  `protected void`
  `fireActionEvent(int x, int y)`
  Allows subclasses to override action event behavior for pointer coordinates.
  `String[]`
  `getBindablePropertyNames()`
  Returns the names of the properties within this component that can be bound for persistence, the order of these names mean that the first one will be the first bound
  `Class[]`
  `getBindablePropertyTypes()`
  Returns the types of the properties that are bindable within this component
  `Object`
  `getBoundPropertyValue(String prop)`
  Allows the binding code to extract the value of the property
  `boolean`
  `isOppositeSide()`
  Places the check box on the opposite side at the far end
  `boolean`
  `isSelected()`
  Return true if the checkbox is selected
  `void`
  `paint(Graphics g)`
  This method paints the Component on the screen, it should be overriden by subclasses to perform custom drawing or invoke the UI API's to let the PLAF perform the rendering.
  `protected String`
  `paramString()`
  Returns a string representing the state of this component.
  `void`
  `refreshTheme(boolean merge)`
  Makes sure the component is up to date with the current theme, ONLY INVOKE THIS METHOD IF YOU CHANGED THE THEME!
  `void`
  `released(int x, int y)`
  Invoked to change the state of the button to the released state
  `void`
  `removeChangeListeners(ActionListener l)`
  Removes a change change listener.
  `void`
  `setBoundPropertyValue(String prop, Object value)`
  Sets the value of a bound property within this component, notice that this method MUST NOT fire the property change event when invoked to prevent recursion!
  `void`
  `setOppositeSide(boolean oppositeSide)`
  Places the check box on the opposite side at the far end
  `void`
  `setSelected(boolean selected)`
  Selects the current checkbox
  `void`
  `unbindProperty(String prop, BindTarget target)`
  Removes a bind target from the given property name

  ### Methods inherited from class Button

  `addActionListener, addStateChangeListener, animate, bindStateTo, dragInitiated, fireClicked, getActionListeners, getBorder, getCommand, getDisabledIcon, getIconFromState, getListeners, getPressedIcon, getReleaseRadius, getRolloverIcon, getRolloverPressedIcon, getState, isAutoRelease, isButtonRippleEffectDefault, isCapsText, isCapsTextDefault, isSelectableInteraction, isToggle, keyPressed, keyReleased, keyRepeated, pointerHover, pointerHoverReleased, pointerPressed, pointerReleased, pressed, released, removeActionListener, removeStateChangeListener, resetFocusable, setAlignment, setAutoRelease, setButtonRippleEffectDefault, setCapsText, setCapsTextDefault, setCommand, setDisabledIcon, setPressedIcon, setReleased, setReleaseRadius, setRolloverIcon, setRolloverPressedIcon, setText, setToggle, setUIID, unbindStateFrom`
  Modifier and Type
  Method
  Description
  `void`
  `addActionListener(ActionListener<ActionEvent> l)`
  Adds a listener to the button which will cause an event to dispatch on click
  `void`
  `addStateChangeListener(ActionListener<ComponentStateChangeEvent> l)`
  Adds a listener to be notified when the button state changes.
  `boolean`
  `animate()`
  Allows the animation to reduce "repaint" calls when it returns false.
  `void`
  `bindStateTo(Button button)`
  Bind the state of this button to another button's state.
  `protected void`
  `dragInitiated()`
  Invoked on the focus component to let it know that drag has started on the parent container for the case of a component that doesn't support scrolling
  `protected void`
  `fireClicked()`
  When working in 3 softbutton mode "fire" key (center softbutton) is sent to this method in order to allow 3 button devices to work properly.
  `Vector<ActionListener<ActionEvent>>`
  `getActionListeners()`
  Returns a vector containing the action listeners for this button
  `protected Border`
  `getBorder()`
  Normally returns getStyle().getBorder() but some subclasses might use this to programmatically replace the border in runtime e.g.
  `Command`
  `getCommand()`
  This method return the Button Command if exists
  `Image`
  `getDisabledIcon()`
  Indicates the icon that is displayed on the button when the button is in the disabled state
  `Image`
  `getIconFromState()`
  Returns the icon for the button based on its current state
  `Collection<ActionListener<ActionEvent>>`
  `getListeners()`
  Returns a collection containing the action listeners for this button
  `Image`
  `getPressedIcon()`
  Indicates the icon that is displayed on the button when the button is in pressed state
  `int`
  `getReleaseRadius()`
  Indicates a radius in which a pointer release will still have effect.
  `Image`
  `getRolloverIcon()`
  Indicates the icon that is displayed on the button when the button is in rolled over state
  `Image`
  `getRolloverPressedIcon()`
  Indicates the icon that is displayed on the button when the button is in pressed state and is selected.
  `int`
  `getState()`
  Returns the button state
  `boolean`
  `isAutoRelease()`
  Returns if this is an auto released Button.
  `static boolean`
  `isButtonRippleEffectDefault()`
  Default value for the button ripple effect, this can be set with the theme constant buttonRippleBool
  `final boolean`
  `isCapsText()`
  Indicates whether text on the button should be drawn capitalized by default to match the Android design.
  `static boolean`
  `isCapsTextDefault()`
  Indicates whether text on the button should be drawn capitalized by default to match the Android design.
  `protected boolean`
  `isSelectableInteraction()`
  This method allows a component to indicate that it is interested in an "implicit" select command to appear in the "fire" button when 3 softbuttons are defined in a device.
  `boolean`
  `isToggle()`
  Toggle button mode is only relevant for checkboxes/radio buttons.
  `void`
  `keyPressed(int keyCode)`
  If this Component is focused, the key pressed event will call this method
  `void`
  `keyReleased(int keyCode)`
  If this Component is focused, the key released event will call this method
  `void`
  `keyRepeated(int keyCode)`
  If this Component is focused, the key repeat event will call this method.
  `void`
  `pointerHover(int[] x, int[] y)`
  Invoked for devices where the pointer can hover without actually clicking the display.
  `void`
  `pointerHoverReleased(int[] x, int[] y)`
  Invoked for devices where the pointer can hover without actually clicking the display.
  `void`
  `pointerPressed(int x, int y)`
  If this Component is focused, the pointer pressed event will call this method
  `void`
  `pointerReleased(int x, int y)`
  If this Component is focused, the pointer released event will call this method
  `void`
  `pressed()`
  Invoked to change the state of the button to the pressed state
  `void`
  `released()`
  Invoked to change the state of the button to the released state
  `void`
  `removeActionListener(ActionListener<ActionEvent> l)`
  Removes the given action listener from the button
  `void`
  `removeStateChangeListener(ActionListener<ComponentStateChangeEvent> l)`
  Removes state change listener.
  `protected void`
  `resetFocusable()`
  Restores the state of the focusable flag to its default state
  `void`
  `setAlignment(int align)`
  Sets the Alignment of the Label to one of: CENTER, LEFT, RIGHT
  `void`
  `setAutoRelease(boolean autoRelease)`
  Sets the auto released mode of this button, by default it's not an auto released Button
  `static void`
  `setButtonRippleEffectDefault(boolean aButtonRippleEffectDefault)`
  Default value for the button ripple effect, this can be set with the theme constant buttonRippleBool
  `void`
  `setCapsText(boolean capsText)`
  Indicates whether text on the button should be drawn capitalized by default to match the Android design.
  `static void`
  `setCapsTextDefault(boolean aCapsTextDefault)`
  Indicates whether text on the button should be drawn capitalized by default to match the Android design This value can be set by the `capsButtonTextBool` theme constant
  `void`
  `setCommand(Command cmd)`
  Applies the given command to this button
  `void`
  `setDisabledIcon(Image disabledIcon)`
  Indicates the icon that is displayed on the button when the button is in the disabled state
  `void`
  `setPressedIcon(Image pressedIcon)`
  Indicates the icon that is displayed on the button when the button is in pressed state
  `void`
  `setReleased()`
  Set the button in released and unfocused state
  `void`
  `setReleaseRadius(int releaseRadius)`
  Indicates a radius in which a pointer release will still have effect.
  `void`
  `setRolloverIcon(Image rolloverIcon)`
  Indicates the icon that is displayed on the button when the button is in rolled over state
  `void`
  `setRolloverPressedIcon(Image rolloverPressedIcon)`
  Indicates the icon that is displayed on the button when the button is in pressed state and is selected.
  `void`
  `setText(String t)`
  Overriden to implement the caps mode `#setCapsText(boolean)` Sets the Label text
  `void`
  `setToggle(boolean toggle)`
  Toggle button mode is only relevant for checkboxes/radio buttons.
  `void`
  `setUIID(String id)`
  Overriden to workaround issue with caps text and different UIID's This method sets the Component the Unique identifier.
  `void`
  `unbindStateFrom(Button button)`
  Unbinds the state of this button from another button.

  ### Methods inherited from class Label

  `getAlignment, getBadgeStyleComponent, getBadgeText, getBaseline, getBaselineResizeBehavior, getDefaultGap, getFontIcon, getFontIconSize, getGap, getIcon, getIconFont, getIconStyleComponent, getIconUIID, getMask, getMaskedIcon, getMaskName, getMaterialIcon, getMaterialIconSize, getMaxAutoSize, getMinAutoSize, getPropertyNames, getPropertyTypeNames, getPropertyTypes, getPropertyValue, getShiftMillimeters, getShiftMillimetersF, getShiftText, getStringWidth, getText, getTextPosition, getTextSelectionSupport, getVerticalAlignment, initLaf, initUnselectedStyle, isAutoSizeMode, isDefaultTickerEnabled, isEndsWith3Points, isLegacyRenderer, isShouldLocalize, isShowEvenIfBlank, isTextSelectionEnabled, isTickerEnabled, isTickerRunning, laidOut, setAutoSizeMode, setBadgeText, setBadgeUIID, setDefaultGap, setDefaultTickerEnabled, setEndsWith3Points, setFontIcon, setFontIcon, setFontIcon, setGap, setIcon, setIconUIID, setLegacyRenderer, setMask, setMaskName, setMaterialIcon, setMaterialIcon, setMaxAutoSize, setMinAutoSize, setPropertyValue, setShiftMillimeters, setShiftMillimeters, setShiftText, setShouldLocalize, setShowEvenIfBlank, setTextPosition, setTextSelectionEnabled, setTickerEnabled, setVerticalAlignment, shouldTickerStart, startTicker, startTicker, stopTicker, styleChanged`
  Modifier and Type
  Method
  Description
  `int`
  `getAlignment()`
  Returns the alignment of the Label
  `Component`
  `getBadgeStyleComponent()`
  Gets a component that can be used for the style of the badge.
  `String`
  `getBadgeText()`
  Gets the text to be used in a badge on this label.
  `int`
  `getBaseline(int width, int height)`
  The baseline for the component text according to which it should be aligned with other components for best visual look.
  `int`
  `getBaselineResizeBehavior()`
  Returns a constant indicating how the baseline varies with the size of the component.
  `static int`
  `getDefaultGap()`
  Returns the default gap in pixels between the icon/text to the Label boundaries
  `char`
  `getFontIcon()`
  Returns the font icon assigned to this component or 0 if not applicable
  `float`
  `getFontIconSize()`
  Returns the icon size assigned to this component or 0/-1 if not applicable
  `int`
  `getGap()`
  Returns the gap in pixels between the icon/text to the Label boundaries
  `Image`
  `getIcon()`
  Returns the labels icon
  `Font`
  `getIconFont()`
  Returns the font for the icon font or null if not font set
  `Component`
  `getIconStyleComponent()`
  Gets the component that should be used for styling material the material icon.
  `String`
  `getIconUIID()`
  Gets the UIID used for styling material icons on this component.
  `Object`
  `getMask()`
  Returns the mask matching the given image
  `Image`
  `getMaskedIcon()`
  If a mask is applied returns the icon with a mask, otherwise returns the icon
  `String`
  `getMaskName()`
  Determines the name of the mask from the image constants thus allowing the mask to be applied from the theme
  `char`
  `getMaterialIcon()`
  Returns the material icon assigned to this component or 0 if not applicable
  `float`
  `getMaterialIconSize()`
  Returns the material icon size assigned to this component or 0/-1 if not applicable
  `float`
  `getMaxAutoSize()`
  Allows us to limit the maximum size for the autosize mode
  `float`
  `getMinAutoSize()`
  Allows us to limit the minimum size for the autosize mode
  `String[]`
  `getPropertyNames()`
  A component may expose mutable property names for a UI designer to manipulate, this API is designed for usage internally by the GUI builder code
  `String[]`
  `getPropertyTypeNames()`
  This method is here to workaround an XMLVM array type bug where property types aren't identified properly, it returns the names of the types using the following type names: String,int,double,long,byte,short,char,String[],String[][],byte[],Image,Image[],Object[],ListModel,ListCellRenderer
  `Class[]`
  `getPropertyTypes()`
  Matches the property names method (see that method for further details).
  `Object`
  `getPropertyValue(String name)`
  Returns the current value of the property name, this method is used by the GUI builder
  `int`
  `getShiftMillimeters()`
  Returns the number of millimeters that should be shifted in tickering rounded to nearest int.
  `float`
  `getShiftMillimetersF()`
  Returns the number of millimeters that should be shifted in tickering as a float.
  `int`
  `getShiftText()`
  Simple getter to return how many pixels to shift the text inside the Label
  `int`
  `getStringWidth(Font fnt)`
  This method is equivalent to label.getStyle().getFont().stringWidth(label.getText()) but its faster
  `String`
  `getText()`
  Returns the label text
  `int`
  `getTextPosition()`
  Returns The position of the text relative to the icon
  `TextSelection.TextSelectionSupport`
  `getTextSelectionSupport()`
  Returns text selection support object for this component.
  `int`
  `getVerticalAlignment()`
  Returns the vertical alignment of the Label, this will only work when the icon is in the side of the text and not above or below it.
  `protected void`
  `initLaf(UIManager uim)`
  This method initializes the Component defaults constants
  `protected void`
  `initUnselectedStyle(Style unselectedStyle)`
  Can be overridden by subclasses to perform initialization when the unselected style is set to a new value.
  `boolean`
  `isAutoSizeMode()`
  Autosize mode automatically shrinks/grows the font of the label to fit in the available width, it carries a noticeable performance penalty and we recommend you avoid using it unless absolutely necessary
  `static boolean`
  `isDefaultTickerEnabled()`
  Allows disabling/enabling tickers globally
  `boolean`
  `isEndsWith3Points()`
  If the Label text is too long fit the text to the widget and adds "`...`" points at the end.
  `boolean`
  `isLegacyRenderer()`
  Fallback to the old default look and feel renderer for cases where compatibility is essential
  `boolean`
  `isShouldLocalize()`
  Indicates if text should be localized when set to the label, by default all text is localized so this allows disabling automatic localization for a specific label.
  `boolean`
  `isShowEvenIfBlank()`
  By default labels and subclasses become 0 sized when they are blank even ignoring their padding setting this to true makes the padding take effect even in a blank field.
  `boolean`
  `isTextSelectionEnabled()`
  Returns true if text selection is enabled on this label.
  `boolean`
  `isTickerEnabled()`
  This method return true if the ticker is enabled on this Label
  `boolean`
  `isTickerRunning()`
  Returns true if the ticker is running
  `protected void`
  `laidOut()`
  This is a callback method to inform the Component when it's been laidout on the parent Container
  `void`
  `setAutoSizeMode(boolean autoSizeMode)`
  Autosize mode automatically shrinks/grows the font of the label to fit in the available width, it carries a noticeable performance penalty and we recommend you avoid using it unless absolutely necessary
  `void`
  `setBadgeText(String badgeText)`
  Sets the badge text to be used on this label.
  `void`
  `setBadgeUIID(String badgeUIID)`
  Sets the style that should be used for rendering badges.
  `static void`
  `setDefaultGap(int gap)`
  Set the default gap in pixels between the icon/text to the Label boundaries
  `static void`
  `setDefaultTickerEnabled(boolean aDefaultTickerEnabled)`
  Allows disabling/enabling tickers globally
  `void`
  `setEndsWith3Points(boolean endsWith3Points)`
  If the Label text is too long fit the text to the widget and adds "`...`" points at the end.
  `void`
  `setFontIcon(char c)`
  Sets an icon font using either the same icon font that was used to set the icon font last, or using the font from the icon UIID.
  `void`
  `setFontIcon(Font font, char c)`
  This method is shorthand for `Font, char, float)`
  `void`
  `setFontIcon(Font font, char c, float size)`
  This method is shorthand for `com.codename1.ui.Font, char, float)`
  `void`
  `setGap(int gap)`
  Set the gap in pixels between the icon/text to the Label boundaries
  `void`
  `setIcon(Image icon)`
  Sets the Label icon, if the icon is unmodified a repaint would not be triggered
  `void`
  `setIconUIID(String uiid)`
  Sets a UIID to be used for the material icon style.
  `void`
  `setLegacyRenderer(boolean legacyRenderer)`
  Fallback to the old default look and feel renderer for cases where compatibility is essential
  `void`
  `setMask(Object mask)`
  A mask image can be applied to the label (see the image mask method for details) which allows for things like rounded image appearance etc.
  `void`
  `setMaskName(String maskName)`
  Determines the name of the mask from the image constants thus allowing the mask to be applied from the theme
  `void`
  `setMaterialIcon(char c)`
  This method is shorthand for `char)`
  `void`
  `setMaterialIcon(char c, float size)`
  This method is shorthand for `char, float)`
  `void`
  `setMaxAutoSize(float maxSize)`
  Allows us to limit the maximum size for the autosize mode
  `void`
  `setMinAutoSize(float minSize)`
  Allows us to limit the minimum size for the autosize mode
  `String`
  `setPropertyValue(String name, Object value)`
  Sets a new value to the given property, returns an error message if failed and null if successful.
  `void`
  `setShiftMillimeters(float shiftMillimeters)`
  Sets the millimeters that should be shifted in tickering as a float.
  `void`
  `setShiftMillimeters(int shiftMillimeters)`
  Sets the millimeters that should be shifted in tickering
  `void`
  `setShiftText(int shiftText)`
  This method shifts the text from it's position in pixels.
  `void`
  `setShouldLocalize(boolean shouldLocalize)`
  Indicates if text should be localized when set to the label, by default all text is localized so this allows disabling automatic localization for a specific label.
  `final void`
  `setShowEvenIfBlank(boolean showEvenIfBlank)`
  By default labels and subclasses become 0 sized when they are blank even ignoring their padding setting this to true makes the padding take effect even in a blank field.
  `void`
  `setTextPosition(int textPosition)`
  Sets the position of the text relative to the icon if exists
  `void`
  `setTextSelectionEnabled(boolean enabled)`
  Enables text selection on this label.
  `void`
  `setTickerEnabled(boolean tickerEnabled)`
  Sets the Label to allow ticking of the text.
  `void`
  `setVerticalAlignment(int valign)`
  Sets the vertical alignment of the Label to one of: CENTER, TOP, BOTTOM, BASELINE
  `boolean`
  `shouldTickerStart()`
  Returns true if a ticker should be started since there is no room to show the text in the label.
  `void`
  `startTicker()`
  This method will start the text ticker
  `void`
  `startTicker(long delay, boolean rightToLeft)`
  This method will start the text ticker
  `void`
  `stopTicker()`
  Stops the text ticker
  `void`
  `styleChanged(String propertyName, Style source)`
  Invoked to indicate a change in a propertyName of a Style

  ### Methods inherited from class Component

  `addDragFinishedListener, addDragOverListener, addDropListener, addFocusListener, addLongPressListener, addPointerDraggedListener, addPointerPressedListener, addPointerReleasedListener, addPullToRefresh, addScrollListener, announceForAccessibility, blocksSideSwipe, calcScrollSize, cancelRepaints, clearClientProperties, contains, containsOrOwns, createStyleAnimation, deinitialize, deinitializeCustomStyle, dragEnter, dragExit, dragFinished, draggingOver, drawDraggedImage, drop, focusGained, focusLost, getAbsoluteX, getAbsoluteY, getAccessibilityText, getAllStyles, getAnimationManager, getBottomGap, getBounds, getBounds, getClientProperty, getCloudBoundProperty, getCloudDestinationProperty, getComponentForm, getComponentState, getCursor, getDefaultDragTransparency, getDirtyRegion, getDisabledStyle, getDraggedx, getDraggedy, getDragImage, getDragRegionStatus, getDragSpeed, getDragTransparency, getEditingDelegate, getGridPosX, getGridPosY, getHeight, getInlineAllStyles, getInlineDisabledStyles, getInlinePressedStyles, getInlineSelectedStyles, getInlineStylesTheme, getInlineUnselectedStyles, getInnerHeight, getInnerPreferredH, getInnerPreferredW, getInnerWidth, getInnerX, getInnerY, getLabelForComponent, getName, getNativeOverlay, getNextFocusDown, getNextFocusLeft, getNextFocusRight, getNextFocusUp, getOuterHeight, getOuterPreferredH, getOuterPreferredW, getOuterWidth, getOuterX, getOuterY, getOwner, getParent, getPreferredH, getPreferredSize, getPreferredSizeStr, getPreferredTabIndex, getPreferredW, getPressedStyle, getSameHeight, getSameWidth, getScrollable, getScrollAnimationSpeed, getScrollDimension, getScrollOpacity, getScrollOpacityChangeSpeed, getScrollX, getScrollY, getSelectCommandText, getSelectedRect, getSelectedStyle, getSideGap, getStyle, getTabIndex, getTensileLength, getTooltip, getUIID, getUIManager, getUnselectedStyle, getVisibleBounds, getVisibleBounds, getWidth, getX, getY, growShrink, handlesInput, hasFixedPreferredSize, hasFocus, hideNativeOverlay, initComponent, initCustomStyle, initDisabledStyle, initPressedStyle, initSelectedStyle, installDefaultPainter, isAlwaysTensile, isBlockLead, isCellRenderer, isChildOf, isDragActivated, isDragAndDropOperation, isDraggable, isDragRegion, isDropTarget, isEditable, isEditing, isEnabled, isFlatten, isFocusable, isGrabsPointerEvents, isHidden, isHidden, isHideInLandscape, isHideInPortrait, isIgnorePointerEvents, isInClippingRegion, isInitialized, isOpaque, isOwnedBy, isPinchBlocksDragAndDrop, isRippleEffect, isRTL, isScrollable, isScrollableX, isScrollableY, isScrollVisible, isSetCursorSupported, isSmoothScrolling, isSnapToGrid, isStickyDrag, isTactileTouch, isTactileTouch, isTensileDragEnabled, isTraversable, isVisible, longKeyPress, longPointerPress, onScrollX, onScrollY, onSetFocusable, paintBackground, paintBackgrounds, paintBorder, paintBorderBackground, paintComponent, paintComponent, paintIntersectingComponentsAbove, paintLock, paintLockRelease, paintRippleOverlay, paintScrollbars, paintScrollbarX, paintScrollbarY, paintShadows, parsePreferredSize, pinch, pinch, pinchReleased, pointerDragged, pointerDragged, pointerHoverPressed, pointerPressed, pointerReleased, putClientProperty, refreshTheme, refreshTheme, remove, removeDragFinishedListener, removeDragOverListener, removeDropListener, removeFocusListener, removeLongPressListener, removePointerDraggedListener, removePointerPressedListener, removePointerReleasedListener, removeScrollListener, repaint, repaint, requestFocus, respondsToPointerEvents, scrollRectToVisible, scrollRectToVisible, setAccessibilityText, setAlwaysTensile, setBlockLead, setCellRenderer, setCloudBoundProperty, setCloudDestinationProperty, setComponentState, setCursor, setDefaultDragTransparency, setDirtyRegion, setDisabledStyle, setDraggable, setDragTransparency, setDropTarget, setEditingDelegate, setEnabled, setFlatten, setFocus, setFocusable, setGrabsPointerEvents, setHandlesInput, setHeight, setHidden, setHidden, setHideInLandscape, setHideInPortrait, setIgnorePointerEvents, setInitialized, setInlineAllStyles, setInlineDisabledStyles, setInlinePressedStyles, setInlineSelectedStyles, setInlineStylesTheme, setInlineUnselectedStyles, setIsScrollVisible, setLabelForComponent, setName, setNextFocusDown, setNextFocusLeft, setNextFocusRight, setNextFocusUp, setOpaque, setOwner, setPinchBlocksDragAndDrop, setPreferredH, setPreferredSize, setPreferredSizeStr, setPreferredTabIndex, setPreferredW, setPressedStyle, setRippleEffect, setRTL, setSameHeight, setSameSize, setSameWidth, setScrollAnimationSpeed, setScrollOpacityChangeSpeed, setScrollSize, setScrollVisible, setScrollX, setScrollY, setSelectCommandText, setSelectedStyle, setShouldCalcPreferredSize, setSize, setSmoothScrolling, setSnapToGrid, setTabIndex, setTactileTouch, setTensileDragEnabled, setTensileLength, setTooltip, setTraversable, setUIID, setUIIDFinal, setUnselectedStyle, setVisible, setWidth, setX, setY, shouldBlockSideSwipe, shouldBlockSideSwipeLeft, shouldBlockSideSwipeRight, shouldRenderComponentSelection, showNativeOverlay, startEditingAsync, stopEditing, stripMarginAndPadding, toImage, toString, updateNativeOverlay, visibleBoundsContains`
  Modifier and Type
  Method
  Description
  `void`
  `addDragFinishedListener(ActionListener l)`
  Adds a listener to the dragFinished event
  `void`
  `addDragOverListener(ActionListener l)`
  Broadcasts an event when dragging over a component
  `void`
  `addDropListener(ActionListener l)`
  Binds an action listener to drop events which are invoked when this component is dropped on a target
  `void`
  `addFocusListener(FocusListener l)`
  Registers interest in receiving callbacks for focus gained events, a focus event is invoked when the component accepts the focus.
  `void`
  `addLongPressListener(ActionListener l)`
  Adds a listener to the pointer event
  `void`
  `addPointerDraggedListener(ActionListener l)`
  Adds a listener to the pointer event
  `void`
  `addPointerPressedListener(ActionListener l)`
  Adds a listener to the pointer event
  `void`
  `addPointerReleasedListener(ActionListener l)`
  Adds a listener to the pointer event
  `void`
  `addPullToRefresh(Runnable task)`
  This method adds a refresh task to the Component, the task will be executed if the user has pulled the scroll beyond a certain height.
  `void`
  `addScrollListener(ScrollListener l)`
  Registers interest in receiving callbacks for scroll gained events, a scroll event is invoked when the component is scrolled.
  `void`
  `announceForAccessibility(String text)`
  Manually announces text to native accessibility services, associating the announcement with this component when possible.
  `final boolean`
  `blocksSideSwipe()`
  A component that might need side swipe such as the slider could block it from being used for some other purpose when on top of said component.
  `protected Dimension`
  `calcScrollSize()`
  Method that can be overriden to represent the actual size of the component when it differs from the desireable size for the viewport
  `protected void`
  `cancelRepaints()`
  remove this component from the painting queue
  `void`
  `clearClientProperties()`
  Clears all client properties from this Component
  `boolean`
  `contains(int x, int y)`
  Returns true if the given absolute coordinate is contained in the Component
  `boolean`
  `containsOrOwns(int x, int y)`
  Checks to see if this component either contains the given point, or if it owns the component that contains the given point.
  `ComponentAnimation`
  `createStyleAnimation(String destUIID, int duration)`
  Creates an animation that will transform the current component to the styling of the destination UIID when completed.
  `protected void`
  `deinitialize()`
  Invoked to indicate that the component initialization is being reversed since the component was detached from the container hierarchy.
  `protected void`
  `deinitializeCustomStyle(Style s)`
  Allows components to create a style of their own, this method cleans up state for the given style
  `protected void`
  `dragEnter(Component dragged)`
  This callback method indicates that a component drag has just entered this component
  `protected void`
  `dragExit(Component dragged)`
  This callback method provides an indication for a drop target that a drag operation is exiting the bounds of this component and it should clear all relevant state if such state exists.
  `protected void`
  `dragFinished(int x, int y)`
  Callback indicating that the drag has finished either via drop or by releasing the component
  `protected boolean`
  `draggingOver(Component dragged, int x, int y)`
  This method allows a component to indicate if it is a drop target for the given component at the given x/y location (in component coordiate space).
  `protected void`
  `drawDraggedImage(Graphics g, Image img, int x, int y)`
  Draws the given image at x/y, this method can be overriden to draw additional information such as positive or negative drop indication
  `void`
  `drop(Component dragged, int x, int y)`
  Performs a drop operation of the component at the given X/Y location in coordinate space, this method should be overriden by subclasses to perform all of the logic related to moving a component, by default this method does nothing and so dragging a component and dropping it has no effect
  `protected void`
  `focusGained()`
  Callback allowing a developer to track when the component gains focus
  `protected void`
  `focusLost()`
  Callback allowing a developer to track wheh the component loses focus
  `int`
  `getAbsoluteX()`
  Returns the absolute X location based on the component hierarchy, this method calculates a location on the screen for the component rather than a relative location as returned by getX()
  `int`
  `getAbsoluteY()`
  Returns the absolute Y location based on the component hierarchy, this method calculates a location on the screen for the component rather than a relative location as returned by getX()
  `String`
  `getAccessibilityText()`
  Returns the text that describes this component to assistive technologies.
  `final Style`
  `getAllStyles()`
  Returns a "meta style" that allows setting styles once to all the different Style objects, the getters for this style will be meaningless and will return 0 values.
  `AnimationManager`
  `getAnimationManager()`
  Returns the animation manager of the parent form or null if this component isn't currently associated with a form
  `int`
  `getBottomGap()`
  Returns the gap to be left for the bottom scrollbar on the X axis.
  `protected Rectangle`
  `getBounds()`
  Returns the component bounds which is sometimes more convenient than invoking getX/Y/Width/Height.
  `Rectangle`
  `getBounds(Rectangle rect)`
  Returns the bounds of this component in the provided Rectangle.
  `Object`
  `getClientProperty(String key)`
  Client properties allow the association of meta-data with a component, this is useful for some applications that construct GUI's on the fly and need to track the connection between the UI and the data.
  `String`
  `getCloudBoundProperty()`
  Indicates the property within this component that should be bound to the cloud object
  `String`
  `getCloudDestinationProperty()`
  The destination property of the CloudObject
  `Form`
  `getComponentForm()`
  Returns the Component Form or null if this Component is not added yet to a form
  `Object`
  `getComponentState()`
  Some components may optionally generate a state which can then be restored using setCompnentState().
  `int`
  `getCursor()`
  Gets the custom cursor for this component.
  `static byte`
  `getDefaultDragTransparency()`
  Returns the default translucency used in the `#getDragImage()` method.
  `final Rectangle`
  `getDirtyRegion()`
  gets the Component dirty region, this method is for internal use only and SHOULD NOT be invoked by user code.
  `Style`
  `getDisabledStyle()`
  Returns the Component Style for the disabled state allowing us to manipulate the look of the component when its disabled
  `int`
  `getDraggedx()`
  Gets the current dragged x values when the Component is being dragged
  `int`
  `getDraggedy()`
  Gets the current dragged y values when the Component is being dragged
  `protected Image`
  `getDragImage()`
  This method returns an image representing the dragged component, it can be overriden by subclasses to customize the look of the image, the image will be overlaid on top of the form during a drag and drop operation
  `protected int`
  `getDragRegionStatus(int x, int y)`
  Indicates if the section within the X/Y area is a "drag region" where we expect people to drag or press in which case we can instantly start dragging making perceived performance faster.
  `protected float`
  `getDragSpeed(boolean vertical)`
  This method returns the dragging speed based on the latest dragged events
  `byte`
  `getDragTransparency()`
  Returns the translucency used in the `#getDragImage()` method.
  `Editable`
  `getEditingDelegate()`
  Gets the delegate that handles the editing of this component.
  `protected int`
  `getGridPosX()`
  This method should be implemented correctly by subclasses to make snap to grid functionality work as expected.
  `protected int`
  `getGridPosY()`
  This method should be implemented correctly by subclasses to make snap to grid functionality work as expected.
  `int`
  `getHeight()`
  Returns the component height
  `String`
  `getInlineAllStyles()`
  Gets inline styles that are to be applied to all states of this component.
  `String`
  `getInlineDisabledStyles()`
  Gets inline styles that are to be applied to the disabled state of this component.
  `String`
  `getInlinePressedStyles()`
  Gets inline styles that are to be applied to the pressed state of this component.
  `String`
  `getInlineSelectedStyles()`
  Gets inline styles that are to be applied to the selected state of this component.
  `Resources`
  `getInlineStylesTheme()`
  Gets the theme that is used by inline styles to reference images.
  `String`
  `getInlineUnselectedStyles()`
  Gets inline styles that are to be applied to the unselected state of this component.
  `int`
  `getInnerHeight()`
  Gets the inner height of this component.
  `int`
  `getInnerPreferredH()`
  Gets the preferred height removing vertical padding.
  `int`
  `getInnerPreferredW()`
  Gets the preferred width removing horizontal padding.
  `int`
  `getInnerWidth()`
  Gets the inner width of this component.
  `int`
  `getInnerX()`
  Gets x-coordinate of the inner bounds of this component.
  `int`
  `getInnerY()`
  Gets the inner y-coordinate of the inner bounds of this component.
  `Label`
  `getLabelForComponent()`
  Allows us to indicate the label associated with this component thus providing visual feedback related for this component e.g.
  `String`
  `getName()`
  A component name allows us to easily identify the component within a dynamic UI.
  `Object`
  `getNativeOverlay()`
  Gets the native overlay for this component.
  `Component`
  `getNextFocusDown()`
  Allows us to determine which component will receive focus next when traversing with the down key
  `Component`
  `getNextFocusLeft()`
  Allows us to determine which component will receive focus next when traversing with the left key.
  `Component`
  `getNextFocusRight()`
  Allows us to determine which component will receive focus next when traversing with the right key
  `Component`
  `getNextFocusUp()`
  Allows us to determine which component will receive focus next when traversing with the up key.
  `int`
  `getOuterHeight()`
  Gets the outer height of this component.
  `int`
  `getOuterPreferredH()`
  Gets the preferred height including the vertical margins.
  `int`
  `getOuterPreferredW()`
  Gets the preferred width including horizontal margins.
  `int`
  `getOuterWidth()`
  Gets the outer width of this component.
  `int`
  `getOuterX()`
  Gets the x-coordinate of the outer bounds of this component.
  `int`
  `getOuterY()`
  Gets the Y-coordinate of the outer bounds of this component.
  `Component`
  `getOwner()`
  Gets the "owner" of this component as set by `#setOwner(com.codename1.ui.Component)`.
  `Container`
  `getParent()`
  Returns the container in which this component is contained
  `int`
  `getPreferredH()`
  Helper method to retrieve the preferred height of the component.
  `Dimension`
  `getPreferredSize()`
  Returns the Component Preferred Size, there is no guarantee the Component will be sized at its Preferred Size.
  `String`
  `getPreferredSizeStr()`
  Returns the preferred size string that can be used to specify the preferred size of the component using pixels or millimetres.
  `int`
  `getPreferredTabIndex()`
  Gets the preferred tab index of this component.
  `int`
  `getPreferredW()`
  Helper method to retrieve the preferred width of the component.
  `Style`
  `getPressedStyle()`
  Returns the Component Style for the pressed state allowing us to manipulate the look of the component when it is pressed
  `Component[]`
  `getSameHeight()`
  Returns the array of components that have an equal height
  `Component[]`
  `getSameWidth()`
  Returns the array of components that have an equal width
  `Component`
  `getScrollable()`
  Returns the scrollable parent of this component
  `int`
  `getScrollAnimationSpeed()`
  Scroll animation speed in milliseconds allowing a developer to slow down or accelerate the smooth animation mode
  `Dimension`
  `getScrollDimension()`
  Returns the Components dimension in scrolling, this is very similar to the preferred size aspect only it represents actual scrolling limits.
  `int`
  `getScrollOpacity()`
  This method is used internally by the look and feel to implement the fading scrollbar behavior.
  `int`
  `getScrollOpacityChangeSpeed()`
  Indicates the decrement units for the scroll opacity
  `int`
  `getScrollX()`
  Indicates the X position of the scrolling, this number is relative to the component position and so a position of 0 would indicate the x position of the component.
  `int`
  `getScrollY()`
  Indicates the Y position of the scrolling, this number is relative to the component position and so a position of 0 would indicate the y position of the component.
  `String`
  `getSelectCommandText()`
  Allows determining the text for the select command used in the 3rd softbutton mode.
  `Rectangle`
  `getSelectedRect()`
  Returns the component bounds with absolute screen coordinates, for components that include an internal selection behavior and are not containers (currently only List) this method allows returning the position of the selection itself which is useful for things such as the popup dialog and similar UI's that need to reference the position of the selection externally
  `Style`
  `getSelectedStyle()`
  Returns the Component Style for the selected state allowing us to manipulate the look of the component when it owns focus
  `int`
  `getSideGap()`
  Returns the gap to be left for the side scrollbar on the Y axis.
  `Style`
  `getStyle()`
  Returns the current Component Style allowing code to draw the current component, you should normally use getUnselected/Pressed/DisabledStyle() and not this method since it will return different values based on component state.
  `int`
  `getTabIndex()`
  Gets the tab index of the component.
  `int`
  `getTensileLength()`
  Recommended length for the tensile, -1 for default
  `String`
  `getTooltip()`

  ###### Returns

  `final String`
  `getUIID()`
  Unique identifier for a component.
  `UIManager`
  `getUIManager()`
  This method should be used by the Component to retrieve the correct UIManager to work with
  `final Style`
  `getUnselectedStyle()`
  Returns the Component Style for the unselected mode allowing us to manipulate the look of the component
  `protected Rectangle`
  `getVisibleBounds()`
  Returns the component bounds for scrolling which might differ from the getBounds for large components e.g.
  `Rectangle`
  `getVisibleBounds(Rectangle rect)`
  Returns the component bounds for scrolling which might differ from the getBounds for large components into the provided rectangle.
  `int`
  `getWidth()`
  Returns the component width
  `int`
  `getX()`
  Returns the current component x location relatively to its parent container
  `int`
  `getY()`
  Returns the component y location relatively to its parent container
  `void`
  `growShrink(int duration)`
  Grows or shrinks this component to its new preferred size, this method essentially takes a component whose preferred size has changed and creates a "growing" effect that lasts for the duration.
  `boolean`
  `handlesInput()`
  Prevents key events from being grabbed for focus traversal.
  `boolean`
  `hasFixedPreferredSize()`
  Checks if this component has a fixed preferred size either via an explicit call to `#setPreferredH(int)` and `#setPreferredW(int)`, or via a preferred size style string.
  `boolean`
  `hasFocus()`
  Returns true if the component has focus
  `protected void`
  `hideNativeOverlay()`
  Hides the native overlay for this component.
  `protected void`
  `initComponent()`
  Allows subclasses to bind functionality that relies on fully initialized and "ready for action" component state
  `protected void`
  `initCustomStyle(Style s)`
  Allows components to create a style of their own, this method binds the listener to the style and installs a bg painter
  `protected void`
  `initDisabledStyle(Style disabledStyle)`
  Can be overridden by subclasses to perform initialization when the disabled style is set to a new value.
  `protected void`
  `initPressedStyle(Style pressedStyle)`
  Can be overridden by subclasses to perform initialization when the pressed style is set to a new value.
  `protected void`
  `initSelectedStyle(Style selectedStyle)`
  Can be overridden by subclasses to perform initialization when the selected style is set to a new value.
  `protected void`
  `installDefaultPainter(Style s)`
  Allows subclasses to create their own custom style types and install the background painter into them
  `boolean`
  `isAlwaysTensile()`
  Enable the tensile drag to work even when a component doesn't have a scroll showable (scrollable flag still needs to be set to true)
  `boolean`
  `isBlockLead()`
  Prevent a lead component hierarchy from this specific component, this allows a component within that hierarchy to still act as a standalone component
  `boolean`
  `isCellRenderer()`
  Used as an optimization to mark that this component is currently being used as a cell renderer
  `boolean`
  `isChildOf(Container cnt)`
  Searches the hierarchy of the component recursively to see if the given Container is one of the parents of this component
  `protected boolean`
  `isDragActivated()`
  Indicates whether we are in the middle of a drag operation, this method allows developers overriding the pointer released events to know when this is a drag operation.
  `protected boolean`
  `isDragAndDropOperation(int x, int y)`
  This method allows a developer to define only a specific portion of a component as draggable by default it returns true if the component is defined as "draggable"
  `boolean`
  `isDraggable()`
  Indicates whether this component can be dragged in a drag and drop operation rather than scroll the parent
  `protected boolean`
  `isDragRegion(int x, int y)`
  Indicates if the section within the X/Y area is a "drag region" where we expect people to drag and never actually "press" in which case we can instantly start dragging making perceived performance faster.
  `boolean`
  `isDropTarget()`
  Indicates whether this component can receive dropped components into it, notice that when dropping on a component or container the parents will be checked recursively to find a valid drop target
  `boolean`
  `isEditable()`
  Checks to see if the component is editable.
  `boolean`
  `isEditing()`
  Checks if the component is currently being edited.
  `boolean`
  `isEnabled()`
  Indicates whether component is enabled or disabled thus allowing us to prevent a component from receiving input events and indicate so visually
  `boolean`
  `isFlatten()`
  Makes the component effectively opaque by blending the backgrounds into an image in memory so the layer of underlying components is only drawn once when this component is repainted.
  `boolean`
  `isFocusable()`
  Returns true if this component can receive focus and is enabled
  `boolean`
  `isGrabsPointerEvents()`
  This property is useful for blocking in z-order touch events, sometimes we might want to grab touch events in a specific component without making it focusable.
  `boolean`
  `isHidden()`
  Returns true if the component was explicitly hidden by the user.
  `boolean`
  `isHidden(boolean checkParent)`
  Checks if the component is hidden.
  `boolean`
  `isHideInLandscape()`
  Indicates that this component and all its children should be hidden when the device is switched to landscape mode
  `boolean`
  `isHideInPortrait()`
  Indicates that this component and all its children should be hidden when the device is switched to portrait mode
  `boolean`
  `isIgnorePointerEvents()`

  ###### Returns

  `protected boolean`
  `isInClippingRegion(Graphics g)`
  `protected boolean`
  `isInitialized()`
  Indicates if the component is in the initialized state, a component is initialized when its initComponent() method was invoked.
  `boolean`
  `isOpaque()`
  Checks whether the component's background should be painted.
  `boolean`
  `isOwnedBy(Component cmp)`
  Checks to see if this component is owned by the given other component.
  `boolean`
  `isPinchBlocksDragAndDrop()`
  returns true if pinch will block drag and drop
  `boolean`
  `isRippleEffect()`
  Indicates whether the component displays the material design ripple effect
  `final boolean`
  `isRTL()`
  Is the component a bidi RTL component
  `protected boolean`
  `isScrollable()`
  Indicates whether the component should/could scroll by default a component is not scrollable.
  `boolean`
  `isScrollableX()`
  Indicates whether the component should/could scroll on the X axis
  `boolean`
  `isScrollableY()`
  Indicates whether the component should/could scroll on the Y axis
  `boolean`
  `isScrollVisible()`
  Indicate whether this component scroll is visible
  `static boolean`
  `isSetCursorSupported()`
  Checks to see if this platform supports cursors.
  `boolean`
  `isSmoothScrolling()`
  Indicates that scrolling through the component should work as an animation
  `boolean`
  `isSnapToGrid()`
  Indicates whether scrolling this component should jump to a specific location in a grid
  `protected boolean`
  `isStickyDrag()`
  Returns true if the component is interested in receiving drag/pointer release events even after the gesture exceeded its boundaries.
  `boolean`
  `isTactileTouch()`
  Indicates whether the component should "trigger" tactile touch when pressed by the user in a touch screen UI.
  `protected boolean`
  `isTactileTouch(int x, int y)`
  Elaborate components might not provide tactile feedback for all their areas (e.g. Lists) this method defaults to returning the value of isTactileTouch
  `boolean`
  `isTensileDragEnabled()`
  Indicates whether tensile drag (dragging beyond the boundry of the component and snapping back) is enabled for this component.
  `final boolean`
  `isTraversable()`
  Checks if this component should be traversable using the keyboard using tab, next, previous keys.
  `boolean`
  `isVisible()`
  Returns whether the component is visible or not
  `protected void`
  `longKeyPress(int keyCode)`
  If this Component is focused this method is invoked when the user presses and holds the key
  `void`
  `longPointerPress(int x, int y)`
  If this Component is focused this method is invoked when the user presses and holds the pointer on the Component
  `protected void`
  `onScrollX(int scrollX)`
  This method can be overriden to receive scroll events, unlike overriding setScrollX it will receive all calls for scrolling.
  `protected void`
  `onScrollY(int scrollY)`
  This method can be overriden to receive scroll events, unlike overriding setScrollY it will receive all calls for scrolling.
  `protected void`
  `onSetFocusable(boolean focusable)`
  Since setFocusable is final this callback is invoked when focusable changes.
  `protected void`
  `paintBackground(Graphics g)`
  This method paints the Component background, it should be overriden by subclasses to perform custom background drawing.
  `void`
  `paintBackgrounds(Graphics g)`
  This method paints all the parents Components Background.
  `protected void`
  `paintBorder(Graphics g)`
  Draws the component border if such a border exists.
  `protected void`
  `paintBorderBackground(Graphics g)`
  Draws the component border background if such a border exists.
  `final void`
  `paintComponent(Graphics g)`
  Paints this component as a root by going to all the parent components and setting the absolute translation based on coordinates and scroll status.
  `final void`
  `paintComponent(Graphics g, boolean background)`
  Paints this component as a root by going to all the parent components and setting the absolute translation based on coordinates and scroll status.
  `void`
  `paintIntersectingComponentsAbove(Graphics g)`
  Paints intersecting components that appear above this component.
  `Image`
  `paintLock(boolean hardLock)`
  This method locks the component so it will always paint the given image instead of running through its paint logic.
  `void`
  `paintLockRelease()`
  Releases the paint lock image to allow paint to work as usual, see paintLock(boolean) for details
  `void`
  `paintRippleOverlay(Graphics g, int x, int y, int position)`
  Invoked to draw the ripple effect overlay in Android where the finger of the user causes a growing circular overlay over time.
  `protected void`
  `paintScrollbars(Graphics g)`
  Paints the UI for the scrollbars on the component, this will be invoked only for scrollable components.
  `protected void`
  `paintScrollbarX(Graphics g)`
  Paints the UI for the scrollbar on the X axis, this method allows component subclasses to customize the look of a scrollbar
  `protected void`
  `paintScrollbarY(Graphics g)`
  Paints the UI for the scrollbar on the Y axis, this method allows component subclasses to customize the look of a scrollbar
  `void`
  `paintShadows(Graphics g, int relativeX, int relativeY)`
  Paints the drop-shadow projections for this component based on its elevation value.
  `static Dimension`
  `parsePreferredSize(String preferredSize, Dimension baseSize)`
  Parses the preferred size given as a string
  `protected boolean`
  `pinch(float scale)`
  Invoked by subclasses interested in handling pinch to zoom events, if true is returned other drag events will not be broadcast
  `protected boolean`
  `pinch(int[] x, int[] y)`
  Invoked by subclasses interested in handling pinch to do their own actions based on the position of the two fingers, if true is returned other drag events will not be broadcast
  `protected void`
  `pinchReleased(int x, int y)`
  To be implemented by subclasses interested in being notified when a pinch zoom has ended (i.e the user has removed one of their fingers, but is still dragging).
  `void`
  `pointerDragged(int[] x, int[] y)`
  If this Component is focused, the pointer dragged event will call this method
  `void`
  `pointerDragged(int x, int y)`
  If this Component is focused, the pointer dragged event will call this method
  `void`
  `pointerHoverPressed(int[] x, int[] y)`
  Invoked for devices where the pointer can hover without actually clicking the display.
  `void`
  `pointerPressed(int[] x, int[] y)`
  If this Component is focused, the pointer pressed event will call this method
  `void`
  `pointerReleased(int[] x, int[] y)`
  If this Component is focused, the pointer released event will call this method
  `void`
  `putClientProperty(String key, Object value)`
  Client properties allow the association of meta-data with a component, this is useful for some applications that construct GUI's on the fly and need to track the connection between the UI and the data.
  `void`
  `refreshTheme()`
  Makes sure the component is up to date with the current theme, ONLY INVOKE THIS METHOD IF YOU CHANGED THE THEME!
  `protected void`
  `refreshTheme(String id, boolean merge)`
  Makes sure the component is up to date with the given UIID
  `void`
  `remove()`
  This method will remove the Component from its parent.
  `void`
  `removeDragFinishedListener(ActionListener l)`
  Removes the listener from the drag finished event
  `void`
  `removeDragOverListener(ActionListener l)`
  Removes an action listener to drag over events
  `void`
  `removeDropListener(ActionListener l)`
  Removes an action listener to drop events which are invoked when this component is dropped on a target
  `void`
  `removeFocusListener(FocusListener l)`
  Deregisters interest in receiving callbacks for focus gained events
  `void`
  `removeLongPressListener(ActionListener l)`
  Removes the listener from the pointer event
  `void`
  `removePointerDraggedListener(ActionListener l)`
  Removes the listener from the pointer event
  `void`
  `removePointerPressedListener(ActionListener l)`
  Removes the listener from the pointer event
  `void`
  `removePointerReleasedListener(ActionListener l)`
  Removes the listener from the pointer event
  `void`
  `removeScrollListener(ScrollListener l)`
  Deregisters interest in receiving callbacks for scroll gained events
  `void`
  `repaint()`
  Repaint this Component, the repaint call causes a callback of the paint method on the event dispatch thread.
  `void`
  `repaint(int x, int y, int w, int h)`
  Repaints a specific region within the component
  `void`
  `requestFocus()`
  Changes the current component to the focused component, will work only for a component that belongs to a parent form.
  `boolean`
  `respondsToPointerEvents()`
  Checks if the component responds to pointer events.
  `void`
  `scrollRectToVisible(int x, int y, int width, int height, Component coordinateSpace)`
  Makes sure the component is visible in the scroll if this container is scrollable
  `protected void`
  `scrollRectToVisible(Rectangle rect, Component coordinateSpace)`
  Makes sure the component is visible in the scroll if this container is scrollable
  `void`
  `setAccessibilityText(String text)`
  Sets the text that describes this component to assistive technologies.
  `void`
  `setAlwaysTensile(boolean alwaysTensile)`
  Enable the tensile drag to work even when a component doesn't have a scroll showable (scrollable flag still needs to be set to true)
  `void`
  `setBlockLead(boolean blockLead)`
  Prevent a lead component hierarchy from this specific component, this allows a component within that hierarchy to still act as a standalone component
  `void`
  `setCellRenderer(boolean cellRenderer)`
  Used as an optimization to mark that this component is currently being used as a cell renderer
  `void`
  `setCloudBoundProperty(String cloudBoundProperty)`
  Indicates the property within this component that should be bound to the cloud object
  `void`
  `setCloudDestinationProperty(String cloudDestinationProperty)`
  The destination property of the CloudObject
  `void`
  `setComponentState(Object state)`
  If getComponentState returned a value the setter can update the value and restore the prior state.
  `void`
  `setCursor(int cursor)`
  Sets a custom mouse cursor for this component if the platform supports mouse cursors, notice that this isn't applicable for touch devices.
  `static void`
  `setDefaultDragTransparency(byte defaultDragTransparency)`
  Sets the default translucency of the `#getDragImage()` method.
  `final void`
  `setDirtyRegion(Rectangle dirty)`
  sets the Component dirty region, this method is for internal use only and SHOULD NOT be invoked by user code.
  `void`
  `setDisabledStyle(Style style)`
  Changes the Component disalbed Style by replacing the Component Style with the given Style
  `void`
  `setDraggable(boolean draggable)`
  Indicates whether this component can be dragged in a drag and drop operation rather than scroll the parent
  `void`
  `setDragTransparency(byte dragTransparency)`
  Sets the translucency of the `#getDragImage()` method.
  `void`
  `setDropTarget(boolean dropTarget)`
  Indicates whether this component can receive dropped components into it, notice that when dropping on a component or container the parents will be checked recursively to find a valid drop target
  `void`
  `setEditingDelegate(Editable editable)`
  Sets the editing delegate for this component.
  `void`
  `setEnabled(boolean enabled)`
  Indicates whether component is enabled or disabled thus allowing us to prevent a component from receiving input events and indicate so visually
  `void`
  `setFlatten(boolean flatten)`
  Makes the component effectively opaque by blending the backgrounds into an image in memory so the layer of underlying components is only drawn once when this component is repainted.
  `void`
  `setFocus(boolean focused)`
  This flag doesn't really give focus, its a state that determines what colors from the Style should be used when painting the component.
  `final void`
  `setFocusable(boolean focusable)`
  A simple setter to determine if this Component can get focused
  `void`
  `setGrabsPointerEvents(boolean grabsPointerEvents)`
  This property is useful for blocking in z-order touch events, sometimes we might want to grab touch events in a specific component without making it focusable.
  `void`
  `setHandlesInput(boolean handlesInput)`
  Prevents key events from being grabbed for focus traversal.
  `void`
  `setHeight(int height)`
  Sets the Component height, this method is exposed for the purpose of external layout managers and should not be invoked directly.
  `void`
  `setHidden(boolean b)`
  Makes the components preferred size equal 0 when hidden and restores it to the default size when not.
  `void`
  `setHidden(boolean b, boolean changeMargin)`
  Makes the components preferred size equal 0 when hidden and restores it to the default size when not.
  `void`
  `setHideInLandscape(boolean hideInLandscape)`
  Indicates that this component and all its children should be hidden when the device is switched to landscape mode
  `void`
  `setHideInPortrait(boolean hideInPortrait)`
  Indicates that this component and all its children should be hidden when the device is switched to portrait mode
  `void`
  `setIgnorePointerEvents(boolean ignorePointerEvents)`

  ###### Parameters

  `protected void`
  `setInitialized(boolean initialized)`
  Indicates if the component is in the initialized state, a component is initialized when its initComponent() method was invoked.
  `void`
  `setInlineAllStyles(String styles)`
  Registers inline styles that should be applied to all states of the component.
  `void`
  `setInlineDisabledStyles(String styles)`
  Registers inline styles that should be applied to the disabled state of the component.
  `void`
  `setInlinePressedStyles(String styles)`
  Registers inline styles that should be applied to the pressed state of the component.
  `void`
  `setInlineSelectedStyles(String styles)`
  Registers inline styles that should be applied to the selected state of the component.
  `void`
  `setInlineStylesTheme(Resources inlineStylesTheme)`
  Sets the theme that is used by inline styles to reference images.
  `void`
  `setInlineUnselectedStyles(String styles)`
  Registers inline styles that should be applied to the unselected state of the component.
  `void`
  `setIsScrollVisible(boolean isScrollVisible)`
  Set whether this component scroll is visible
  `void`
  `setLabelForComponent(Label componentLabel)`
  Allows us to indicate the label associated with this component thus providing visual feedback related for this component e.g.
  `void`
  `setName(String name)`
  A component name allows us to easily identify the component within a dynamic UI.
  `void`
  `setNextFocusDown(Component nextFocusDown)`
  Allows us to determine which component will receive focus next when traversing with the down key
  `void`
  `setNextFocusLeft(Component nextFocusLeft)`
  Allows us to determine which component will receive focus next when traversing with the left key, this method doesn't affect the general focus behavior.
  `void`
  `setNextFocusRight(Component nextFocusRight)`
  Allows us to determine which component will receive focus next when traversing with the right key
  `void`
  `setNextFocusUp(Component nextFocusUp)`
  Allows us to determine which component will receive focus next when traversing with the up key, this method doesn't affect the general focus behavior.
  `final void`
  `setOpaque(boolean opaque)`
  Sets whether or not to paint the component background.
  `void`
  `setOwner(Component owner)`
  Sets the owner of this component to the specified component.
  `void`
  `setPinchBlocksDragAndDrop(boolean block)`
  If a component supports pinch as well as drag and drop the two may conflict (if one finger is placed a bit before the other, the drag timer will be initiated and may trigger drag even if the second finger has been placed before).
  `void`
  `setPreferredH(int preferredH)`
  Helper method to set the preferred height of the component.
  `void`
  `setPreferredSize(Dimension d)`
  Sets the Component Preferred Size, there is no guarantee the Component will be sized at its Preferred Size.
  `void`
  `setPreferredSizeStr(String value)`

  ###### Parameters

  `void`
  `setPreferredTabIndex(int index)`
  Sets the preferred tab index of the component.
  `void`
  `setPreferredW(int preferredW)`
  Helper method to set the preferred width of the component.
  `void`
  `setPressedStyle(Style style)`
  Sets the Component Style for the pressed state allowing us to manipulate the look of the component when it is pressed
  `void`
  `setRippleEffect(boolean rippleEffect)`
  Indicates whether the component displays the material design ripple effect
  `void`
  `setRTL(boolean rtl)`
  Is the component a bidi RTL component
  `static void`
  `setSameHeight(Component... c)`
  Places all of these components in the same height group, to remove a component from the group invoke this method with that component only.
  `static void`
  `setSameSize(Component... c)`
  This is identical to invoking `#sameWidth` followed by `#sameHeight`
  `static void`
  `setSameWidth(Component... c)`
  Places all of these components in the same width group, to remove a component from the group invoke this method with that component only.
  `void`
  `setScrollAnimationSpeed(int animationSpeed)`
  Scroll animation speed in milliseconds allowing a developer to slow down or accelerate the smooth animation mode
  `void`
  `setScrollOpacityChangeSpeed(int scrollOpacityChangeSpeed)`
  Indicates the decrement units for the scroll opacity
  `void`
  `setScrollSize(Dimension d)`
  Set the size for the scroll area
  `void`
  `setScrollVisible(boolean isScrollVisible)`
  Set whether this component scroll is visible
  `protected void`
  `setScrollX(int scrollX)`
  Indicates the X position of the scrolling, this number is relative to the component position and so a position of 0 would indicate the x position of the component.
  `protected void`
  `setScrollY(int scrollY)`
  Indicates the Y position of the scrolling, this number is relative to the component position and so a position of 0 would indicate the y position of the component.
  `void`
  `setSelectCommandText(String selectText)`
  Allows determining the text for the select command used in the 3rd softbutton mode.
  `void`
  `setSelectedStyle(Style style)`
  Changes the Component selected Style by replacing the Component Style with the given Style
  `void`
  `setShouldCalcPreferredSize(boolean shouldCalcPreferredSize)`
  Indicates the values within the component have changed and preferred size should be recalculated
  `void`
  `setSize(Dimension d)`
  Sets the Component size, this method is exposed for the purpose of external layout managers and should not be invoked directly.
  `void`
  `setSmoothScrolling(boolean smoothScrolling)`
  Indicates that scrolling through the component should work as an animation
  `void`
  `setSnapToGrid(boolean snapToGrid)`
  Indicates whether scrolling this component should jump to a specific location in a grid
  `void`
  `setTabIndex(int index)`
  Sets the tab index of the component.
  `void`
  `setTactileTouch(boolean tactileTouch)`
  Indicates whether the component should "trigger" tactile touch when pressed by the user in a touch screen UI.
  `void`
  `setTensileDragEnabled(boolean tensileDragEnabled)`
  Indicates whether tensile drag (dragging beyond the boundry of the component and snapping back) is enabled for this component.
  `void`
  `setTensileLength(int tensileLength)`
  Recommended length for the tensile, -1 for default
  `void`
  `setTooltip(String tooltip)`

  ###### Parameters

  `final void`
  `setTraversable(boolean traversable)`
  Sets whether this component is traversable using the keyboard using tab, next, previous keys.
  `void`
  `setUIID(String portraitUiid, String landscapeUiid)`
  This method sets the Component the Unique identifier.
  `protected final void`
  `setUIIDFinal(String id)`
  This method is the implementation of setUIID and is defined as final to allow invocation from constructors.
  `void`
  `setUnselectedStyle(Style style)`
  Changes the Component Style by replacing the Component Style with the given Style
  `void`
  `setVisible(boolean visible)`
  Toggles visibility of the component
  `void`
  `setWidth(int width)`
  Sets the Component width, this method is exposed for the purpose of external layout managers and should not be invoked directly.
  `void`
  `setX(int x)`
  Sets the Component x location relative to the parent container, this method is exposed for the purpose of external layout managers and should not be invoked directly.
  `void`
  `setY(int y)`
  Sets the Component y location relative to the parent container, this method is exposed for the purpose of external layout managers and should not be invoked directly.
  `protected boolean`
  `shouldBlockSideSwipe()`
  A component that might need side swipe such as the slider could block it from being used for some other purpose when on top of said component.
  `protected boolean`
  `shouldBlockSideSwipeLeft()`
  A component that might need side swipe such as the tabs could block it from being used for some other purpose when on top of said component.
  `protected boolean`
  `shouldBlockSideSwipeRight()`
  A component that might need side swipe such as the tabs could block it from being used for some other purpose when on top of said component.
  `protected boolean`
  `shouldRenderComponentSelection()`
  A component can indicate whether it is interested in rendering it's selection explicitly, this defaults to true in non-touch UI's and false in touch UI's except for the case where a user clicks the screen.
  `protected void`
  `showNativeOverlay()`
  Creates the native overlay for this component.
  `void`
  `startEditingAsync()`
  If the component `#isEditable()`, then this will start the editing process.
  `void`
  `stopEditing(Runnable onFinish)`
  Stops the editing process.
  `Component`
  `stripMarginAndPadding()`
  Convenience method that strips margin and padding from the component, and returns itself for chaining.
  `Image`
  `toImage()`
  Returns the component as an image.
  `String`
  `toString()`
  Overriden to return a useful value for debugging purposes
  `protected void`
  `updateNativeOverlay()`
  Updates the native overlay for this component.
  `boolean`
  `visibleBoundsContains(int x, int y)`
  Returns true if the given absolute coordinate is contained inside the visible bounds of the component.

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `final Class`
  `getClass()`
  Returns the runtime class of an object.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes current thread to wait until another thread invokes the method or the method for this object.
  `final void`
  `wait(long timeout)`
  Causes current thread to wait until either another thread invokes the method or the method for this object, or a specified amount of time has elapsed.
  `final void`
  `wait(long timeout, int nanos)`
  Causes current thread to wait until another thread invokes the method or the method for this object, or some other thread interrupts the current thread, or a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CheckBox

    public CheckBox(String text)

    Constructs a checkbox with the given text

    ###### Parameters

    - `text`: to display next to the checkbox

  - ### CheckBox

    public CheckBox()
    Constructs a checkbox with no text

  - ### CheckBox

    public CheckBox(Image icon)

    Constructs a checkbox with the given icon

    ###### Parameters

    - `icon`: icon to display next to the checkbox

  - ### CheckBox

    public CheckBox(String text, Image icon)

    Constructs a checkbox with the given text and icon

    ###### Parameters

    - `text`: to display next to the checkbox

    - `icon`: icon to display next to the text

- ## Method Details

  - ### createToggle

    public static CheckBox createToggle(String text, Image icon)

    Shorthand for creating the check box setting the icon/text and making it into a toggle button

    ###### Parameters

    - `text`: the text for the button

    - `icon`: the icon for the button

    ###### Returns

    a check box

  - ### createToggle

    public static CheckBox createToggle(String text)

    Shorthand for creating the check box setting the icon/text and making it into a toggle button

    ###### Parameters

    - `text`: the text for the button

    ###### Returns

    a check box

  - ### createToggle

    public static CheckBox createToggle(Image icon)

    Shorthand for creating the check box setting the icon/text and making it into a toggle button

    ###### Parameters

    - `icon`: the icon for the button

    ###### Returns

    a check box

  - ### isSelected

    public boolean isSelected()

    Return true if the checkbox is selected

    ###### Returns

    true if the checkbox is selected

    Overrides:
      `isSelected` in class `Button`

  - ### setSelected

    public void setSelected(boolean selected)

    Selects the current checkbox

    ###### Parameters

    - `selected`: value for selection

  - ### released

    public void released(int x, int y)

    Invoked to change the state of the button to the released state

    ###### Parameters

    - `x`: the x position if a touch event triggered this, -1 if this isn't relevant

    - `y`: the y position if a touch event triggered this, -1 if this isn't relevant

    Overrides:
      `released` in class `Button`

  - ### fireActionEvent

    protected void fireActionEvent(int x, int y)

    Allows subclasses to override action event behavior for pointer coordinates.

    ###### Parameters

    - `x`: the x position of the click if applicable (can be 0 or -1 otherwise)

    - `y`: the y position of the click if applicable (can be 0 or -1 otherwise)

    Overrides:
      `fireActionEvent` in class `Button`

  - ### paint

    public void paint(Graphics g)

    This method paints the Component on the screen, it should be overriden by subclasses to perform custom drawing or invoke the UI API's to let the PLAF perform the rendering.

    ###### Parameters

    - `g`: the component graphics
    Specified by:
      `paint` in interface `Animation`
    Overrides:
      `paint` in class `Button`

  - ### calcPreferredSize

    protected Dimension calcPreferredSize()

    Calculates the preferred size based on component content. This method is invoked lazily by getPreferred size.

    ###### Returns

    the calculated preferred size based on component content

    Overrides:
      `calcPreferredSize` in class `Button`

  - ### paramString

    protected String paramString()

    Returns a string representing the state of this component. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

    ###### Returns

    a string representation of this component's state

    Overrides:
      `paramString` in class `Label`

  - ### refreshTheme

    public void refreshTheme(boolean merge)

    Makes sure the component is up to date with the current theme, ONLY INVOKE THIS METHOD IF YOU CHANGED THE THEME!

    ###### Parameters

    - `merge`: indicates if the current styles should be merged with the new styles
    Overrides:
      `refreshTheme` in class `Label`

  - ### isOppositeSide

    public boolean isOppositeSide()

    Places the check box on the opposite side at the far end

    ###### Returns

    the oppositeSide

    Overrides:
      `isOppositeSide` in class `Button`

  - ### setOppositeSide

    public void setOppositeSide(boolean oppositeSide)

    Places the check box on the opposite side at the far end

    ###### Parameters

    - `oppositeSide`: the oppositeSide to set

  - ### getBindablePropertyNames

    public String[] getBindablePropertyNames()

    Returns the names of the properties within this component that can be bound for persistence, the order of these names mean that the first one will be the first bound

    ###### Returns

    a string array of property names or null

    ###### Deprecated

    this mapped to an older iteration of properties that is no longer used

    Overrides:
      `getBindablePropertyNames` in class `Label`

  - ### getBindablePropertyTypes

    public Class[] getBindablePropertyTypes()

    Returns the types of the properties that are bindable within this component

    ###### Returns

    the class for binding

    ###### Deprecated

    this mapped to an older iteration of properties that is no longer used

    Overrides:
      `getBindablePropertyTypes` in class `Label`

  - ### bindProperty

    public void bindProperty(String prop, BindTarget target)

    Binds the given property name to the given bind target

    ###### Parameters

    - `prop`: the property name

    - `target`: the target binder

    ###### Deprecated

    this mapped to an older iteration of properties that is no longer used

    ###### Deprecated

    uses the deprecated BindTarget interface

    ###### Deprecated

    uses the deprecated BindTarget interface

    Overrides:
      `bindProperty` in class `Label`

  - ### unbindProperty

    public void unbindProperty(String prop, BindTarget target)

    Removes a bind target from the given property name

    ###### Parameters

    - `prop`: the property names

    - `target`: the target binder

    ###### Deprecated

    this mapped to an older iteration of properties that is no longer used

    ###### Deprecated

    uses the deprecated BindTarget interface

    ###### Deprecated

    uses the deprecated BindTarget interface

    Overrides:
      `unbindProperty` in class `Label`

  - ### getBoundPropertyValue

    public Object getBoundPropertyValue(String prop)

    Allows the binding code to extract the value of the property

    ###### Parameters

    - `prop`: the property

    ###### Returns

    the value for the property

    ###### Deprecated

    this mapped to an older iteration of properties that is no longer used

    Overrides:
      `getBoundPropertyValue` in class `Label`

  - ### setBoundPropertyValue

    public void setBoundPropertyValue(String prop, Object value)

    Sets the value of a bound property within this component, notice that this method MUST NOT fire the property change event when invoked to prevent recursion!

    ###### Parameters

    - `prop`: the property whose value should be set

    - `value`: the value

    ###### Deprecated

    this mapped to an older iteration of properties that is no longer used

    Overrides:
      `setBoundPropertyValue` in class `Label`

  - ### addChangeListener

    public void addChangeListener(ActionListener l)

    Adds a listener to be notified when the the checkbox's selected value changes. The difference between a change listener and an action listener is that a change listener is fired whenever there is a change, but action events are only fired when the change is a result of the user clicking on the checkbox.

    ###### Parameters

    - `l`: Listener to be notified when selected value changes.

    ###### Since

    6.0

    ###### See also

    - #removeChangeListener(com.codename1.ui.events.ActionListener)

  - ### removeChangeListeners

    public void removeChangeListeners(ActionListener l)

    Removes a change change listener.

    ###### Parameters

    - `l`

    ###### Since

    6.0

    ###### See also

    - #addChangeListener(com.codename1.ui.events.ActionListener)